## minexpert2 9.5.0

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.18.4)

############################################################
############################################################
# Basic information about project

project(mineXpert2
  DESCRIPTION "A program to visualize and explore mass spectrometric data"
  HOMEPAGE_URL "http://wwww.msxpertsuite.org/minexpert2")

set(LOWCASE_PROJECT_NAME minexpert2)

set(VERSION 9.5.0)

# Set additional project information
set(COMPANY "msXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2016-2024 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


include(GNUInstallDirs)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldRed}The devel directory where all the development projects
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")


# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
include_directories(${CMAKE_SOURCE_DIR})

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN32 if SYSTEM_UNAME_S is "^.*MING64.*"
# Note that WIN32 is set even on 64 bits systems.
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin) and by the Clang-based code analyzer..
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
  execute_process( COMMAND cmake -E copy_if_different
    ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
    ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
  )
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "${BoldGreen}Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall -pedantic.${ColourReset}")
add_definitions(-Wall -pedantic)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message(STATUS "${BoldGreen}Setting definition -Werror.${ColourReset}")
  add_definitions(-Werror)
endif()

message("${BoldGreen}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

  if(MXE)

    # Run the following cmake command line:
    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

  elseif(WIN10MINGW64)
    include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
  endif()

elseif(UNIX)

  #message("UNIX")

  # On UNIX, the libpappsomspp and libpappsomspp-widget libs
  # need to be installed and they ship the PappsoMSppConfig.cmake
  # config file.

  # However, when developing both libs and this program, we need to be able to
  # load the libs from their dev/build directory without relying on the system
  # libs (add -DLOCAL_DEV=1).
  if(LOCAL_DEV)
    # The development should use the locally built libs.
    message("Using the local libpappsomspp libraries.")
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)
  else()
    # The development should use the system-wide libs.
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

  endif()

  message(STATUS "Include dir for PappsoMSpp is at: ${PappsoMSpp_INCLUDE_DIRS}")
  message(STATUS "PappsoMSpp and PappsoMSppWidget were found:
  \t${PappsoMSpp_LIBRARIES} and ${PappsoMSppWidget_LIBRARIES}")

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
  add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# It is essential to run these config steps before delving into the minexpert
# directory, because at that moment they will need what are
# going to prepare right now.
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
  ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX)
  execute_process(COMMAND inkscape
    ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg -o
    ${CMAKE_SOURCE_DIR}/images/splashscreen.png -w 600)
endif()

#############################################################
##################
# BUILD OF LIBMASS

message(STATUS "Adding subdirectory libmass/src for TARGET: ${TARGET}")
add_subdirectory(libmass/src)

#############################################################
#####################
# BUILD OF LIBMASSGUI

message(STATUS "Adding subdirectory libmassgui/src for TARGET: ${TARGET}")
add_subdirectory(libmassgui/src)

#############################################################
######################
# BUILD OF THE PROGRAM

message(STATUS "Adding subdirectory src for TARGET: ${TARGET}")
add_subdirectory(src)

#############################################################
################################
# BUILD OF THE DOC / USER MANUAL
message(STATUS "Adding subdirectory doc for project: ${TARGET}")
add_subdirectory(doc)


# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
configure_file(${CMAKE_UTILS_PATH}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/src/config.h @ONLY)


#############################################################
#############################################################
# Installation prefix
if (NOT CMAKE_INSTALL_PREFIX)
  SET (CMAKE_INSTALL_PREFIX /usr/local)
endif (NOT CMAKE_INSTALL_PREFIX)


####################################################
# Installation directories depending on the platform
####################################################

# See the CMakeStuff/toolchains platform-specific files.
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "BIN_DIR: ${BIN_DIR}")
message(STATUS "DOC_DIR: ${DOC_DIR}")


#############################################################
###########################
# CREATE THE SOURCE PACKAGE
include(${CMAKE_UTILS_PATH}/targz-source-package-creation.cmake)

add_custom_target(archive
  cpack -G TGZ --config CPackSourceConfig.cmake && mv
  ${CMAKE_BINARY_DIR}/${LOWCASE_PROJECT_NAME}-${VERSION}.tar.gz
  ${CMAKE_SOURCE_DIR}/../tarballs && ln -sf
  ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${VERSION}.tar.gz
  ${CMAKE_SOURCE_DIR}/../${LOWCASE_PROJECT_NAME}_${VERSION}.orig.tar.gz && ln -sf
  ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}-${VERSION}.tar.gz
  ${CMAKE_SOURCE_DIR}/../tarballs/${LOWCASE_PROJECT_NAME}_${VERSION}.orig.tar.gz

  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  COMMENT "Creating .tar.gz" VERBATIM
)


#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}   General configuration of the ${CMAKE_PROJECT_NAME} project ${ColourReset}")
message("")

message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}${ColourReset}")

message("")

message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}TARGET: ${TARGET}${ColourReset}")
message(STATUS "${BoldYellow}BIN_DIR: ${BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}DOC_DIR: ${DOC_DIR}${ColourReset}")

if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()

if(WARNASERR)
  message(STATUS "${BoldYellow}Warnings ARE treated as errors (-DWARNASERR=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "${BoldYellow}Debug support IS requested.${ColourReset}")
else()
  message(STATUS "${BoldYellow}Debug support NOT requested.${ColourReset}")
endif()

message("")
message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on win10-mingw64 would be: cmake -DCMAKE_BUILD_TYPE=Release  ../../development${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}")
message("")

if(LOCAL_DEV)
  message("")
  message("${BoldGreen}USING LOCAL DEVELOPMENT CONFIG FOR PAPPSOMSPP")
  message("")
endif()

message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message("")

=== src/CMakeLists.txt ===
message("\n${BoldRed}Now configuring src/ for ${TARGET}${ColourReset}\n")


########################################################
# Files
set(${TARGET}_nongui_SRCS

  # These are the ones I want compile early.
  nongui/QualifiedMassSpectrumVectorMassDataIntegrator.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToRt.cpp
  #
  # Some globals.
  nongui/globals.cpp
  #
  # The classes to look into an MS run prior to loading it
  nongui/MsRunProber.cpp
  nongui/vendor/BrukerTimsTofMsRunProber.cpp
  #
  # The main class that hold the mass data.
  nongui/MsRunDataSet.cpp
  #
  # The class to handle the statistics computation about a given MsRunDataSet.
  nongui/MsRunDataSetStats.cpp
  #
  # The class to load MS run data
  nongui/MassSpecDataFileLoader.cpp

  nongui/MassSpecDataFileLoaderToVector.cpp
  #
  # The classe that monitors integrators.
  nongui/MassDataIntegratorTask.cpp
  #
  # The base class of the integrators.
  nongui/MassDataIntegrator.cpp
  #
  # The various integrators that use BaseMsRunDataSetTreeNodeVisitor.
  nongui/MsRunDataSetTreeMassDataIntegratorToRt.cpp
  #
  # The various MsRunDataSetTreeNodeVisitor classes.
  nongui/BaseMsRunDataSetTreeNodeVisitor.cpp
  nongui/MsRunStatisticsTreeNodeVisitor.cpp
  nongui/TicChromTreeNodeCombinerVisitor.cpp
  nongui/TicChromatogramFromMassSpecDataFile.cpp
  nongui/MultiTreeNodeCombinerVisitor.cpp
  #
  # The various integrators that use QualifiedMassSpectrumVector.
  #nongui/QualifiedMassSpectrumVectorMassDataIntegrator.cpp
  #nongui/QualifiedMassSpectrumVectorMassDataIntegratorToRt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToMz.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToDt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToTicInt.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToDtRtMz.cpp
  nongui/QualifiedMassSpectrumVectorMassDataIntegratorToRtDt.cpp
  #
  # The classes that handle the processing flow
  nongui/ProcessingFlow.cpp
  nongui/ProcessingStep.cpp
  nongui/ProcessingType.cpp
  #
  # The classes that handle the parameters for the various integrations and the
  # display of traces.
  nongui/MsFragmentationSpec.cpp
  #
  # Analysis preferences
  nongui/AnalysisPreferences.cpp
)

set(${TARGET}_gui_SRCS
  gui/Application.cpp
  gui/ProgramWindow.cpp
  gui/MsRunSelectorDlg.cpp
  gui/AboutDlg.cpp
  #
  gui/ConsoleWnd.cpp
  #
  gui/MsRunLoader.cpp
  gui/vendor/BrukerTimsTofMsRunLoader.cpp
  gui/vendor/BrukerBafAsciiMsRunLoader.cpp
  gui/vendor/PwizLiteMsRunLoader.cpp
  gui/XyMsRunLoader.cpp
  gui/MsRunReadTask.cpp
  gui/MsRunProbeTask.cpp
  #
  gui/OpenMsRunDataSetsDlg.cpp
  #
  gui/TaskMonitorCompositeWidget.cpp
  gui/TaskMonitorWnd.cpp
  #
  gui/MsRunProbeInfoViewerDlg.cpp
  #
  # The ms run data set tree view classes
  gui/MsRunDataSetTableViewWnd.cpp
  gui/MsRunDataSetTableViewItem.cpp
  gui/MsRunDataSetTableView.cpp
  gui/MsRunDataSetTableViewModel.cpp
  gui/MsRunDataSetTableViewProxyModel.cpp
  #
  # The MS fragmentation specification dialog
  gui/MsFragmentationSpecDlg.cpp
  #
  # The M/Z integration parameters dialog
  gui/MzIntegrationParamsDlg.cpp
  #
  # The Savitzky-Golay filter params dialog
  gui/SavitzkyGolayFilterParamsDlg.cpp
  #
  # The data plot graph/widget tree classes
  gui/DataPlottableNode.cpp
  gui/DataPlottableTree.cpp
  #
  # The trace plot widgets derived from pappso::BaseTracePlotWidget
  gui/TicXicChromTracePlotWidget.cpp
  gui/MassSpecTracePlotWidget.cpp
  gui/DriftSpecTracePlotWidget.cpp
  #
  # The trace plot composite widgets
  gui/BasePlotCompositeWidget.cpp
  gui/BaseTracePlotCompositeWidget.cpp
  gui/TicXicChromTracePlotCompositeWidget.cpp
  gui/MassSpecTracePlotCompositeWidget.cpp
  gui/DriftSpecTracePlotCompositeWidget.cpp
  #
  # The color map plot composite widgets
  gui/BaseColorMapPlotCompositeWidget.cpp
  gui/TicXicChromMassSpecColorMapPlotCompositeWidget.cpp
  gui/TicXicChromDriftSpecColorMapPlotCompositeWidget.cpp
  gui/DriftSpecMassSpecColorMapPlotCompositeWidget.cpp
  #
  # The plot windows
  gui/BasePlotWnd.cpp
  #
  # Trace plot windows
  gui/BaseTracePlotWnd.cpp
  gui/BaseColorMapPlotWnd.cpp
  gui/TicXicChromTracePlotWnd.cpp
  gui/MassSpecTracePlotWnd.cpp
  gui/DriftSpecTracePlotWnd.cpp
  #
  # Color map plot windows
  gui/TicXicChromMassSpecColorMapWnd.cpp
  gui/TicXicChromDriftSpecColorMapWnd.cpp
  gui/DriftSpecMassSpecColorMapWnd.cpp
  #
  # The save plot to graphics file
  gui/SaveToGraphicsFileDlg.cpp
  #
  # The ProcessingFlow viewer dialog window
  gui/ProcessingFlowViewerDlg.cpp
  #
  # The XIC chromatogram feature
  gui/XicExtractionWnd.cpp
  #
  # Analysis preferences
  gui/AnalysisPreferencesDlg.cpp
  #
  # Labelled widget-based QAction classes
  gui/LabelledDoubleSpinBoxAction.cpp
  gui/LabelledNumberLineEditAction.cpp
  #
  # Plot overlay transparent widget
  gui/PlotAreaOverlay.cpp
)

set(${TARGET}_UIS
  gui/ui/AboutDlg.ui
  gui/ui/MsRunSelectorDlg.ui
  gui/ui/OpenMsRunDataSetsDlg.ui
  gui/ui/MsRunDataSetTableViewWnd.ui
  gui/ui/BasePlotWnd.ui
  gui/ui/BasePlotCompositeWidget.ui
  gui/ui/TaskMonitorCompositeWidget.ui
  gui/ui/TaskMonitorWnd.ui
  gui/ui/ConsoleWnd.ui
  gui/ui/MsFragmentationSpecDlg.ui
  gui/ui/MzIntegrationParamsDlg.ui
  gui/ui/SavitzkyGolayFilterParamsDlg.ui
  gui/ui/SaveToGraphicsFileDlg.ui
  gui/ui/ProcessingFlowViewerDlg.ui
  gui/ui/XicExtractionWnd.ui
  gui/ui/AnalysisPreferencesDlg.ui
  gui/ui/ScriptingWnd.ui
  gui/ui/MsRunProbeInfoViewerDlg.ui
)

qt6_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})

qt6_add_resources(${TARGET}_QRC_CPP ../${LOWCASE_PROJECT_NAME}.qrc)

# Instruct CMake to run automatically when needed the following:
set(CMAKE_AUTOMOC ON) # For meta object compiler
set(CMAKE_AUTORCC ON) # Resource files

###############################################################
# Configuration of the binary to be built
###############################################################

# We had to define some globally-available variables in the libmass and libmassgui
# subdirectories when these libs are built as embedded libs, like we are doing now.

get_property(libmass_INCLUDE_DIRS GLOBAL PROPERTY glob_prop_libmass_INCLUDE_DIRS)
get_property(libmass_LIBRARIES GLOBAL PROPERTY glob_prop_libmass_LIBRARIES)
message(STATUS "Found libmass at: ${libmass_LIBRARIES} with include dir: ${libmass_INCLUDE_DIRS}")

get_property(libmassgui_INCLUDE_DIRS GLOBAL PROPERTY glob_prop_libmassgui_INCLUDE_DIRS)
get_property(libmassgui_LIBRARIES GLOBAL PROPERTY glob_prop_libmassgui_LIBRARIES)

message(STATUS "Found libmassgui at: ${libmassgui_LIBRARIES} with include dir: ${libmassgui_INCLUDE_DIRS}")

message(STATUS "CMAKE_CURRENT_SOURCE_DIR: ${CMAKE_CURRENT_SOURCE_DIR}")

include_directories(

  ${libmass_INCLUDE_DIRS}
  ${libmassgui_INCLUDE_DIRS}

  # The config file is binary directory-specific !!!
  # For the config.h file generated from config.h.in
  # For the ui_Xyyyyy.h files
  ${CMAKE_CURRENT_BINARY_DIR}

  # The omp.h include directory as crafted by looking into the
  # libraries' paths after find_package(OpenMP). See CMake code
  # in the main CMakeLists.txt file.
  ${OpenMP_CXX_INCLUDE_DIRS}

  # For all the source subdirectories
  ${CMAKE_CURRENT_SOURCE_DIR}/nongui
  ${CMAKE_CURRENT_SOURCE_DIR}/gui)


# Only now can we add the executable, because we have defined the sources of the
# object library above.

if(WIN32 OR _WIN32)

  add_executable(${TARGET}
    main.cpp
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
  )

  # In Debug mode we want the console to be opened so that we can read the debug
  # messages. But in Release mode the console is not desirable (the snippet
  # below removes it).
  if(CMAKE_BUILD_TYPE STREQUAL "Release")
    set_property(TARGET ${TARGET} PROPERTY WIN32_EXECUTABLE true)
  endif()

elseif(UNIX)

  add_executable(${TARGET}
    main.cpp
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
  )

endif()


# Finally actually set the linking dependencies to the executable.
# Note that there are so many cross-dependencies that it is virtually unfeasible
# to actually link the binary without resorting to the linker dance steps below.

# Still, I discovered that the order below is good with respect of the symbols
# dependencies resolutions when linking

# The general idea is to first list the libraries that *use* symbols and later
# libraries that *provide* symbols. Which is why all the Qt libs are listed at
# the end and the private libs are listed first.
target_link_libraries(${TARGET}

  OpenMP::OpenMP_CXX

  -Wl,--whole-archive
  ${libmass_LIBRARIES}
  ${libmassgui_LIBRARIES}
  -Wl,--no-whole-archive

  -Wl,--no-as-needed
  PappsoMSpp::Core
  PappsoMSpp::Widget
  -Wl,--as-needed

  -Wl,--no-as-needed
  IsoSpec++::IsoSpec++
  -Wl,--as-needed

  QCustomPlotQt6::QCustomPlotQt6
  QuaZip::QuaZip

  Qt6::Widgets
  Qt6::Svg
  Qt6::PrintSupport
  Qt6::Xml
  Qt6::Network
  # For pappsomspp Bruker timsTOF data handling
  Qt6::Sql
  Qt6::Concurrent
)


if(PROFILE)
  message(STATUS "Profiling is requested, adding linker -pg flag.")
  set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

# We want to install the binary arch-dependent target in
# specific situations. To have proper control, we define the arch
# component.
install(TARGETS ${TARGET}
  RUNTIME
  COMPONENT arch
  DESTINATION ${BIN_DIR})


message("")
message(STATUS "${BoldGreen}Finished configuring of ${TARGET}.${ColourReset}")
message("")

=== doc/user-manual/CMakeLists.txt ===
if(BUILD_USER_MANUAL)

  if(UNIX)

    message("")
    message(STATUS "${BoldGreen}Starting configuration for the user manual for ${CMAKE_PROJECT_NAME} ${ColourReset}")
    message("")

    # The version of the program needs to be set in the user manual front
    # matter.
    configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.cmake.in
      ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)

    # The file driving the user manual build is DC-user-manual.
    # This file contains a config bit that points to the directory
    # that contains de fop.xconf configuration file needed by
    # the FOP utility that crafts the user manual pdf file.

    set(FOP_XCONF_DIR ${CMAKE_SOURCE_DIR}/doc/user-manual)
    configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
      ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY)

    # Start by copying the whole user manual directory to the build directory
    # file(COPY ${CMAKE_SOURCE_DIR}/doc/user-manual DESTINATION ${CMAKE_BINARY_DIR}/doc/)

    # Command:
    # make usermanual
    # Makes use of the local  Makefile file.
    # Will generate HTML and PDF documentation in the build directory

    message("\tConfiguring the user manual compilation")

    # The output of Daps will be in BUILD_DIR.
    add_custom_target(usermanual
      COMMAND make BUILD_DIR=${CMAKE_BINARY_DIR}/doc -f usermanual-makefile all_f
      COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_BINARY_DIR}/doc/user-manual/html ${CMAKE_SOURCE_DIR}/doc/user-manual/html
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc/user-manual
      COMMENT "Build of the DocBook-based user manual \
      documentation in ${CMAKE_BINARY_DIR}/doc")

    install(FILES
      ${CMAKE_BINARY_DIR}/doc/user-manual/${TARGET}-doc.pdf
      DESTINATION ${DOC_DIR})

    install(DIRECTORY
      ${CMAKE_BINARY_DIR}/doc/user-manual/html/user-manual/
      DESTINATION ${DOC_DIR}/html)

    message("")
    message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
    message("")

  else()

    message(STATUS "User manual build skipped")

  endif()

endif()

=== libmassgui/src/CMakeLists.txt ===
message("\nUNIX non APPLE environment\n")
message("\nIf building as the ${CMAKE_PROJECT_NAME} standalone library,
run the build like this:\n")
message("mkdir build; pushd build; cmake -G \"Unix Makefiles\" -DCMAKE_BUILD_TYPE=Debug ../ ; make -j10 ; popd\n")

set(CMAKE_C_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)
set(CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES /usr/include)

# This is used throughout all the build system files
set(TARGET ${LOWCASE_PROJECT_NAME})


message("")
if(STANDALONE_BUILD_MODE)
  message(STATUS "${BoldGreen}Building this library in STANDALONE mode${ColourReset}\n")
else()
  message(STATUS "${BoldGreen}Building this library in EMBEDDED mode${ColourReset}\n")
endif(STANDALONE_BUILD_MODE)
message("")


set(LIBNAME massgui)


message(\n${BoldGreen}"Now configuring library lib${LIBNAME}"${ColourReset}\n)

########################################################
# Files
set(${LIBNAME}_SRCS
  #
  ColorSelector.cpp
  IsotopicClusterGeneratorDlg.cpp
  IsotopicClusterShaperDlg.cpp
  IsotopicDataTableView.cpp
  IsotopicDataTableViewModel.cpp
  MassDataClientServerConfigDlg.cpp
  MassPeakShaperConfigDlg.cpp
  MassPeakShaperConfigWidget.cpp)

set(${LIBNAME}_UIS
  ui/IsotopicClusterGeneratorDlg.ui
  ui/MassPeakShaperConfigDlg.ui
  ui/IsotopicClusterShaperDlg.ui
  ui/ElementGroupBoxWidget.ui
  ui/MassDataClientServerConfigDlg.ui
  ui/MassPeakShaperConfigWidget.ui
)

find_package(Qt6 COMPONENTS Widgets Core Gui PrintSupport Svg Xml Sql Concurrent REQUIRED)

qt6_wrap_ui(${LIBNAME}_UIS_H ${${LIBNAME}_UIS})

qt6_add_resources(${TARGET}_QRC_CPP ../libmassgui-ressources.qrc)

# Because the header files are in their own directory and not along the source
# files, we need to have them listed explicitely for automoc to work properly
# below.

# Create a variable to hold the 'includes' directory *relative* to the
# current CMakeLists.txt file. We need to use ${CMAKE_CURRENT_LIST_DIR}/../
# relative path # instead of ${CMAKE_SOURCE_DIR}/ because that variable
# is going to be modified when the libmass standalone build is replaced by a
# build where libmass is embedded in another source tree.

set(INCLUDE_DIR_RELATIVE_PATH "${CMAKE_CURRENT_LIST_DIR}/../includes")

file(GLOB ${LIBNAME}_HEADERS ${INCLUDE_DIR_RELATIVE_PATH}/lib${LIBNAME}/*.hpp)
message(STATUS "Included the header files from ${INCLUDE_DIR_RELATIVE_PATH}/lib${LIBNAME}")
message(STATUS "The header files: ${${LIBNAME}_HEADERS}")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

###############################################################
# Configuration of the binary to be built
###############################################################

if(STANDALONE_BUILD_MODE)

  message(STATUS "${BoldGreen}Building this library in STANDALONE mode${ColourReset}")

  # We depend on libmass, which we find in its own development directory.

  # We have to include like this: <libmass/header.hpp>

  set(HOME_DEVEL_DIR "$ENV{HOME}/devel")

  set_property(GLOBAL PROPERTY glob_prop_libmass_INCLUDE_DIRS "${HOME_DEVEL_DIR}/libmass/includes")
  set_property(GLOBAL PROPERTY glob_prop_libmass_LIBRARIES "${HOME_DEVEL_DIR}/libmass/libmass.a")

  get_property(libmass_INCLUDE_DIRS GLOBAL PROPERTY glob_prop_libmass_INCLUDE_DIRS)
  get_property(libmass_LIBRARIES GLOBAL PROPERTY glob_prop_libmass_LIBRARIES)

  message(STATUS "Found libmass at: ${libmass_LIBRARIES} with include dir: ${libmass_INCLUDE_DIRS}")

else()

  message(STATUS "${BoldGreen}Building this library in EMBEDDED mode${ColourReset}")

  # Get the lib and include specifs for libmass that has been also built in EMBEDDED mode.

  get_property(libmass_INCLUDE_DIRS GLOBAL PROPERTY glob_prop_libmass_INCLUDE_DIRS)
  get_property(libmass_LIBRARIES GLOBAL PROPERTY glob_prop_libmass_LIBRARIES)

  message(STATUS "Found libmass at: ${libmass_LIBRARIES} with include dir: ${libmass_INCLUDE_DIRS}")

endif()


# Only now can we add the library, because we have defined the sources.

add_library(${LIBNAME} STATIC
  ${${LIBNAME}_HEADERS}
  ${${LIBNAME}_SRCS}
  ${${LIBNAME}_UIS_H}
  ${${TARGET}_QRC_CPP}
  ${PLATFORM_SPECIFIC_SOURCES}
)

target_include_directories(${LIBNAME} PUBLIC
  ${libmass_INCLUDE_DIRS}
  ${INCLUDE_DIR_RELATIVE_PATH}
  ${INCLUDE_DIR_RELATIVE_PATH}/lib${LIBNAME}

  # For the UI compiler output:
  ${CMAKE_CURRENT_BINARY_DIR})

#message(STATUS "CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}")

set_target_properties(${LIBNAME}
  PROPERTIES OUTPUT_NAME ${LIBNAME}
)

add_custom_command(TARGET ${LIBNAME}
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy
  ${CMAKE_CURRENT_BINARY_DIR}/$<TARGET_FILE_NAME:${LIBNAME}>
  ${CMAKE_CURRENT_LIST_DIR}/..
)

# Finally actually set the linking dependencies to the library.
target_link_libraries(${LIBNAME}
  ${libmass_LIBRARIES}

  -Wl,--no-as-needed
  PappsoMSpp::Core
  PappsoMSpp::Widget
  -Wl,--as-needed

  Qt6::Widgets
  Qt6::Xml
  Qt6::Svg

  IsoSpec++::IsoSpec++
)

# This is to avoid the include_next(math.h) file not found error.
if(WIN32)
  set_target_properties(${LIBNAME}
  PROPERTIES NO_SYSTEM_FROM_IMPORTED ON)
endif()


#############################################################
#############################################################
# Platform-specific CMake configuration


# There are two ways this library might be built for use:

# 1. As a standalone library (call cmake directly to the main source directory)
# 2. As an embedded library, for example inside the massXpert2 or mineXpert2 top
# source directories.

# In both cases we might need to know where the built lib is (along with
# the header files), because it might be needed (as standalone, it is typically
# needed for the test binaries).

# When including lib headers from the embedding project the includes must
# be in the form #include <libmass/header.hpp>

set(temp_lib${LIBNAME}_INCLUDE_DIRS "${CMAKE_CURRENT_LIST_DIR}/../includes/")
# For the UICC generated GUI header files.
list(APPEND temp_lib${LIBNAME}_INCLUDE_DIRS "${CMAKE_CURRENT_LIST_DIR}/../includes/lib${LIBNAME}")
list(APPEND temp_lib${LIBNAME}_INCLUDE_DIRS "${CMAKE_CURRENT_BINARY_DIR}")

# When including lib headers from the embedding project the includes must
# be in the form #include <libmass/header.hpp>

set_property(GLOBAL PROPERTY glob_prop_lib${LIBNAME}_INCLUDE_DIRS "${temp_lib${LIBNAME}_INCLUDE_DIRS}")
set_property(GLOBAL PROPERTY glob_prop_lib${LIBNAME}_LIBRARIES "${CMAKE_CURRENT_LIST_DIR}/../lib${LIBNAME}.a")

get_property(lib${LIBNAME}_INCLUDE_DIRS GLOBAL PROPERTY glob_prop_lib${LIBNAME}_INCLUDE_DIRS)
get_property(lib${LIBNAME}_LIBRARIES GLOBAL PROPERTY glob_prop_lib${LIBNAME}_LIBRARIES)

message("")
message(STATUS "Making lib${LIBNAME} headers available at: ${lib${LIBNAME}_INCLUDE_DIRS}.")
message(STATUS "Making lib${LIBNAME} available at ${lib${LIBNAME}_LIBRARIES}.\n")


message("")
message(STATUS "${BoldGreen}Finished configuring of lib${LIBNAME}.${ColourReset}")
message("")

=== debian/changelog ===
minexpert2 (9.5.0-1) unstable; urgency=low

  * Major bug fix and new features:
    - Fix bug in pappsomspp not reading correctly 
      Bruker timsTOF data when restricting the m/z range.
    - Reworked the code about handling the MS run probing
      when loading Bruker timsTOF data files.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 31 May 2024 19:25:09 +0200

minexpert2 (9.4.1-1) unstable; urgency=low

  * Update dependency to new libpappsomspp version.
  * Added maintainer scripts to handle libmass and libmassgui code.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 21 May 2024 19:42:37 +0200

minexpert2 (9.4.0-1) unstable; urgency=low

  * Major work on network communications between mineXpert2 and massXpert2;
  * Now allow for the opening of Bruker BafAscii files (in full only);
  * Fixed missing proper XY mass data loading feature;
  * Really implement libmass and libmassgui source trees as git submodules;
  * Set proper color to widgets that need their parentship with a given
    sample to be clearly visible;
  * Added feature to capture on simple mouse click of the x or y axis value
    on a trace;
  * Implement a QSettings-based memory for the Savitzky-Golay filter parameters.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 16 May 2024 13:30:55 +0200

minexpert2 (9.3.2-1) UNRELEASED; urgency=low

  * Implemented provisions for Bruker timsTOF data that might have
    been integrated by flatteing IMS scans, thus having no
    ion mobility data anymore.

  * Implemented multi m/z XIC extractions.

  * Reworked fully the SelectionPolygon code into a new implementation named
    IntegrationScope.

  * Last fixes to the user manual build system.

  * Update dependency to libpappsomspp (version 0.9.24).

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 07 Dec 2023 12:16:47 +0100

=== debian/control ===
Source: minexpert2
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper (>= 13.3.4),
 dpkg-dev (>= 1.21.22),
# To export from svg to png
 inkscape,
 libgomp1,
 qt6-base-dev,
 libqt6svg6-dev,
 libqt6core5compat6-dev,
 libxkbcommon-x11-dev,
 cmake,
 daps,
 libjs-jquery,
 libjs-highlight.js,
 texlive-fonts-extra,
 fonts-ebgaramond-extra,
 fonts-urw-base35,
 libqcustomplot-dev,
 libisospec++-dev,
 libquazip1-qt6-dev,
 zlib1g-dev,
 libpappsomspp-dev (>= 0.9.34),
 libpappsomspp-widget-dev (>= 0.9.34),
 docbook-xml,
 docbook-to-man
Standards-Version: 4.6.2
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/minexpert2
Vcs-Git: https://salsa.debian.org/debichem-team/minexpert2.git
Rules-Requires-Root: no

Package: minexpert2
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: minexpert2-doc (>= ${source:Upstream-Version})
Description: MS^n mass spectrometric data visualization and mining (runtime)
 mineXpert2 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the mineXpert2 program.


Package: minexpert2-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Description: MS^n mass spectrometric data visualization and mining (doc)
 mineXpert2 allows the user to perform the following tasks:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Display in a table view the full data set, for easy filtering;
  - Calculate and display the TIC chromatogram;
  - Calculate and display a mz=f(rt) color map;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the mass spectrometric data from any kind of data
    representation (mass | drift spectra, TIC | XIC chromatogram,
    2D color maps) to any other kind of data representation;
  - For any mass data feature (mass peak, TIC | XIC peak, color map)
    integrate to a XIC single intensity value;
  - Powerful isotopic cluster calculation starting from a
    chemical formula, optionally with user-defined isotopic abundance ratios;
  - Gaussian fit over any isotopic cluster to estimate the
    average mass of a given ion;
  - Mouse-driven deconvolution of m/z data (charge envelope-based
    or isotopic cluster-based);
  - Export the data to text files;
  - Export the graphical representation of mass spectrometric
    data to graphics files in a number of formats (jpg, png, pdf).
 .
 This package ships the user manual in both PDF and HTML formats.

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Include for DEB_VERSION_UPSTREAM below
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

# Set path to this directory so that our tweaked fop script is used.
PATH := $(CURDIR)/doc/user-manual/scripts:$(PATH)
$(info PATH: $(PATH))


%:
	dh $@

# Required to stop it from calling my convenience Makefile that is only used for
# my day-to-day work.
override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -rf debian/build
	rm -rf debian/tmp
	rm -f libmass/libmass.a
	rm -f libmassgui/libmassgui.a
	rm -f compile_commands.json
	rm -f doc/user-manual/DC-user-manual
	rm -f doc/user-manual/minexpert2-doc.pdf

override_dh_auto_configure:
	mkdir -p debian/build
	mkdir -p debian/tmp
	cd debian/build && cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_USER_MANUAL=1 -DCMAKE_INSTALL_PREFIX=/usr ../..

override_dh_auto_build:
	cd debian/build && make
	cd debian/build && make usermanual

override_dh_compress:
	dh_compress -X.pdf

override_dh_auto_install:
	cd debian/build && DESTDIR=../tmp make install
	dh_install

## minexpert2 9.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 set(LOWCASE_PROJECT_NAME minexpert2)
 
-set(VERSION 9.5.0)
+set(VERSION 9.6.0)
 
 # Set additional project information
 set(COMPANY "msXpertSuite.org")
@@ -22,11 +22,6 @@
 
 
 include(GNUInstallDirs)
-
-set(HOME_DEVEL_DIR $ENV{HOME}/devel)
-message("\n${BoldRed}The devel directory where all the development projects
-should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")
-
 
 # Add folder where are supportive functions
 set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
@@ -76,21 +71,37 @@
 
 #############################################################
 # We do not want warnings for unknown pragmas:
-message(STATUS "${BoldGreen}Setting definition -Wno-unknown-pragmas.${ColourReset}")
+message(STATUS "Setting definition -Wno-unknown-pragmas.")
 add_definitions(-Wno-unknown-pragmas)
 
 # Enable warnings and possibly treat them as errors
-message(STATUS "${BoldGreen}Setting definition -Wall -pedantic.${ColourReset}")
+message(STATUS "Setting definition -Wall -pedantic.")
 add_definitions(-Wall -pedantic)
-message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
+message(STATUS "Setting definition -Wextra.")
 add_definitions(-Wextra)
 
 if(WARN_AS_ERROR)
-  message(STATUS "${BoldGreen}Setting definition -Werror.${ColourReset}")
+  message(STATUS "Setting definition -Werror.")
   add_definitions(-Werror)
 endif()
 
-message("${BoldGreen}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")
+message("CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}")
+
+option(MXE OFF)
+
+option(PAPPSO_LOCAL_DEV OFF)
+option(XPERTMASS_LOCAL_DEV OFF)
+# Same as both above
+option(LOCAL_DEV OFF)
+
+if(LOCAL_DEV)
+set(PAPPSO_LOCAL_DEV ON)
+set(XPERTMASS_LOCAL_DEV ON)
+endif()
+
+message(STATUS "LOCAL_DEV: ${LOCAL_DEV}")
+message(STATUS "PAPPSO_LOCAL_DEV: ${PAPPSO_LOCAL_DEV}")
+message(STATUS "XPERTMASS_LOCAL_DEV: ${XPERTMASS_LOCAL_DEV}")
 
 
 #############################################################
@@ -114,28 +125,9 @@
 
 elseif(UNIX)
 
-  #message("UNIX")
-
-  # On UNIX, the libpappsomspp and libpappsomspp-widget libs
-  # need to be installed and they ship the PappsoMSppConfig.cmake
-  # config file.
-
-  # However, when developing both libs and this program, we need to be able to
-  # load the libs from their dev/build directory without relying on the system
-  # libs (add -DLOCAL_DEV=1).
-  if(LOCAL_DEV)
-    # The development should use the locally built libs.
-    message("Using the local libpappsomspp libraries.")
-    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)
-  else()
-    # The development should use the system-wide libs.
-    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)
-
-  endif()
-
-  message(STATUS "Include dir for PappsoMSpp is at: ${PappsoMSpp_INCLUDE_DIRS}")
-  message(STATUS "PappsoMSpp and PappsoMSppWidget were found:
-  \t${PappsoMSpp_LIBRARIES} and ${PappsoMSppWidget_LIBRARIES}")
+  message("UNIX toolchain being selected")
+
+  include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-common.cmake)
 
 endif()
 
@@ -197,20 +189,6 @@
 endif()
 
 #############################################################
-##################
-# BUILD OF LIBMASS
-
-message(STATUS "Adding subdirectory libmass/src for TARGET: ${TARGET}")
-add_subdirectory(libmass/src)
-
-#############################################################
-#####################
-# BUILD OF LIBMASSGUI
-
-message(STATUS "Adding subdirectory libmassgui/src for TARGET: ${TARGET}")
-add_subdirectory(libmassgui/src)
-
-#############################################################
 ######################
 # BUILD OF THE PROGRAM
 
@@ -220,6 +198,7 @@
 #############################################################
 ################################
 # BUILD OF THE DOC / USER MANUAL
+option(BUILD_USER_MANUAL "Build the user manual, on UNIX only." OFF)
 message(STATUS "Adding subdirectory doc for project: ${TARGET}")
 add_subdirectory(doc)
 
@@ -309,12 +288,18 @@
 message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}")
 message("")
 
-if(LOCAL_DEV)
+if(LOCAL_DEV OR PAPPSO_LOCAL_DEV)
   message("")
-  message("${BoldGreen}USING LOCAL DEVELOPMENT CONFIG FOR PAPPSOMSPP")
+  message("${BoldGreen}USING LOCAL DEVELOPMENT CONFIG FOR PAPPSOMS libraries")
   message("")
 endif()
 
+if(LOCAL_DEV OR XPERTMASS_LOCAL_DEV)
+  message("")
+  message("${BoldGreen}USING LOCAL DEVELOPMENT CONFIG FOR XPERTMASS libraries")
+  message("")
+endif()
+
 message("")
 message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
 message("")

=== Makefile ===
all: 
	cd ../build-area/unix && make -j8

.PHONY: clean
clean:
	cd ../build-area/unix && make clean

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -182,6 +182,12 @@
   gui/ui/MsRunProbeInfoViewerDlg.ui
 )
 
+# These packages are always found, whatever the build configuration
+# (MXE, WIN10 or UNIX)
+
+# Sql below for pappsomspp Bruker timsTOF data handling
+find_package(Qt6 COMPONENTS Widgets Xml Svg PrintSupport Network Sql Concurrent GLOBAL REQUIRED)
+
 qt6_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})
 
 qt6_add_resources(${TARGET}_QRC_CPP ../${LOWCASE_PROJECT_NAME}.qrc)
@@ -190,28 +196,14 @@
 set(CMAKE_AUTOMOC ON) # For meta object compiler
 set(CMAKE_AUTORCC ON) # Resource files
 
+
 ###############################################################
 # Configuration of the binary to be built
 ###############################################################
 
-# We had to define some globally-available variables in the libmass and libmassgui
-# subdirectories when these libs are built as embedded libs, like we are doing now.
-
-get_property(libmass_INCLUDE_DIRS GLOBAL PROPERTY glob_prop_libmass_INCLUDE_DIRS)
-get_property(libmass_LIBRARIES GLOBAL PROPERTY glob_prop_libmass_LIBRARIES)
-message(STATUS "Found libmass at: ${libmass_LIBRARIES} with include dir: ${libmass_INCLUDE_DIRS}")
-
-get_property(libmassgui_INCLUDE_DIRS GLOBAL PROPERTY glob_prop_libmassgui_INCLUDE_DIRS)
-get_property(libmassgui_LIBRARIES GLOBAL PROPERTY glob_prop_libmassgui_LIBRARIES)
-
-message(STATUS "Found libmassgui at: ${libmassgui_LIBRARIES} with include dir: ${libmassgui_INCLUDE_DIRS}")
-
 message(STATUS "CMAKE_CURRENT_SOURCE_DIR: ${CMAKE_CURRENT_SOURCE_DIR}")
 
 include_directories(
-
-  ${libmass_INCLUDE_DIRS}
-  ${libmassgui_INCLUDE_DIRS}
 
   # The config file is binary directory-specific !!!
   # For the config.h file generated from config.h.in
@@ -277,10 +269,10 @@
 
   OpenMP::OpenMP_CXX
 
-  -Wl,--whole-archive
-  ${libmass_LIBRARIES}
-  ${libmassgui_LIBRARIES}
-  -Wl,--no-whole-archive
+  -Wl,--no-as-needed
+  XpertMass::Core
+  XpertMass::Gui
+  -Wl,--as-needed
 
   -Wl,--no-as-needed
   PappsoMSpp::Core

=== doc/user-manual/CMakeLists.txt ===
--- 
+++ 
@@ -20,18 +20,10 @@
     configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
       ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY)
 
-    # Start by copying the whole user manual directory to the build directory
-    # file(COPY ${CMAKE_SOURCE_DIR}/doc/user-manual DESTINATION ${CMAKE_BINARY_DIR}/doc/)
-
-    # Command:
-    # make usermanual
-    # Makes use of the local  Makefile file.
-    # Will generate HTML and PDF documentation in the build directory
-
     message("\tConfiguring the user manual compilation")
 
     # The output of Daps will be in BUILD_DIR.
-    add_custom_target(usermanual
+    add_custom_target(user-manual
       COMMAND make BUILD_DIR=${CMAKE_BINARY_DIR}/doc -f usermanual-makefile all_f
       COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_BINARY_DIR}/doc/user-manual/html ${CMAKE_SOURCE_DIR}/doc/user-manual/html
       WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/doc/user-manual

=== debian/changelog ===
minexpert2 (9.6.0-1) unstable; urgency=low

  * Big new upstream version that new relies on shared libraries
    libxpertmass and libxpertmass-gui instead of having the two
    static libraries made inside the source tree.

    Thus, now depends on libxpertmass-dev (>= 1.0.0).

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 22 Jul 2024 15:01:38 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
 Uploaders: Filippo Rusconi <lopippo@debian.org>
-Build-Depends: debhelper (>= 13.3.4),
+Build-Depends: debhelper-compat (= 13),
  dpkg-dev (>= 1.21.22),
 # To export from svg to png
  inkscape,
@@ -23,8 +23,10 @@
  libisospec++-dev,
  libquazip1-qt6-dev,
  zlib1g-dev,
- libpappsomspp-dev (>= 0.9.34),
+ libpappsomspp-dev (>= 0.9.38),
  libpappsomspp-widget-dev (>= 0.9.34),
+ libxpertmass-dev (>= 1.0.0),
+ libxpertmassgui-dev (>= 1.0.0),
  docbook-xml,
  docbook-to-man
 Standards-Version: 4.6.2

=== debian/rules ===
--- 
+++ 
@@ -43,7 +43,7 @@
 
 override_dh_auto_build:
 	cd debian/build && make
-	cd debian/build && make usermanual
+	cd debian/build && make user-manual
 
 override_dh_compress:
 	dh_compress -X.pdf

=== debian/watch ===
version=4

# The following page lists the releases
# https://gitlab.com/msxpertsuite/minexpert2/-/tags
# And the actual href in the page is
# href="/msxpertsuite/minexpert2/-/archive/8.1.1/minexpert2-8.1.1.tar.gz"

https://gitlab.com/msxpertsuite/minexpert2/-/tags \
    .*/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
